import { CategoryAxisBase } from "./CategoryAxisBase";
import { Type, IList$1 } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesViewer } from "./SeriesViewer";
import { CategoryMode } from "./CategoryMode";
import { IGetItemAtIndex } from "igniteui-angular-core";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
/**
 * @hidden
 */
export declare class CategoryXAxis extends CategoryAxisBase {
    static $t: Type;
    a3(): AxisView;
    gy(a: AxisView): void;
    k6: CategoryXAxisView;
    constructor();
    private li;
    get lk(): number;
    set lk(a: number);
    private lh;
    get lj(): number;
    set lj(a: number);
    au(): AxisLabelPanelBase;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    j0(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    dm(): number;
    lq(a: any): void;
    dz(a: number, b: ScalerParams): number;
    protected k5(a: IList$1<number[]>): number[][];
    gs(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    d0(a: number, b: ScalerParams, c: CategoryMode): number;
    private le;
    d2(a: number, b: ScalerParams): number;
    d3(a: number, b: ScalerParams, c: CategoryMode): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    lr(a: number, b: number): void;
    ll: any;
    protected hd(a: boolean): void;
    cp(): boolean;
    static readonly ls: DependencyProperty;
    get lf(): number;
    set lf(a: number);
    private k8;
    get la(): number;
    set la(a: number);
    ea(): number;
    static readonly lt: DependencyProperty;
    get lg(): number;
    set lg(a: number);
    private k9;
    get lb(): number;
    set lb(a: number);
    jr(a: SeriesViewer): boolean;
    protected get_a1(): AxisOrientation;
    get a1(): AxisOrientation;
    protected k7(): IGetItemAtIndex;
    protected ld(a: number, b: ScalerParams): number;
    protected lc(a: number, b: number, c: boolean, d: ScalerParams): number;
    get isVertical(): boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    get j$a(): boolean;
}
/**
 * @hidden
 */
export declare class CategoryXAxisView extends CategoryAxisBaseView {
    static $t: Type;
    protected bg: CategoryXAxis;
    constructor(a: CategoryXAxis);
}
