import { IgxScatterBaseComponent } from "./igx-scatter-base-component";
import { ScatterSeries } from "./ScatterSeries";
import * as i0 from "@angular/core";
/**
 * Represents a IgxDataChartComponent scatter series
*/
export declare class IgxScatterSeriesComponent extends IgxScatterBaseComponent {
    protected createImplementation(): ScatterSeries;
    /**
                                 * @hidden
                                 */
    get i(): ScatterSeries;
    constructor();
    /**
     * Overridden by derived series classes to indicate when markerless display is preferred or not.
    */
    get isMarkerlessDisplayPreferred(): boolean;
    static ngAcceptInputType_isMarkerlessDisplayPreferred: boolean | string;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxScatterSeriesComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxScatterSeriesComponent, "igx-scatter-series", never, {}, {}, never, never>;
}
