/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __read, __spreadArray, __values } from "tslib";
import { Brush } from "igniteui-angular-core";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { Base, BaseError, EventArgs, runOn, delegateRemove, delegateCombine, typeCast, fromEnum, EnumUtil, Number_$type, String_$type, enumGetBox, markType, TypeRegistrar, fromEn } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { DataSeriesType_$type } from "igniteui-angular-core";
import { IDataSeriesAdapterRule_$type } from "igniteui-angular-core";
import { SimpleFinancialPriceSeriesRule } from "igniteui-angular-core";
import { SubCollectionsRule } from "igniteui-angular-core";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-angular-core";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { ObservableCollection$1 } from "igniteui-angular-core";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerSeries } from "./MarkerSeries";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { ArrayExtension } from "igniteui-angular-core";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ScalerParams } from "./ScalerParams";
import { stringReplace, stringJoin, stringIsNullOrEmpty } from "igniteui-angular-core";
import { timeSpanFromDays } from "igniteui-angular-core";
import { dateMaxValue, dateMinValue } from "igniteui-angular-core";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType_$type } from "igniteui-angular-core";
import { FinancialChartIndicatorMenuContext } from "./FinancialChartIndicatorMenuContext";
import { FinancialChartTypePickerContext } from "./FinancialChartTypePickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
/**
 * @hidden
 */
var FinancialChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChart, _super);
    function FinancialChart() {
        var _this = _super.call(this) || this;
        _this.ss = null;
        _this.va = null;
        _this.u8 = null;
        _this.u5 = null;
        _this.u7 = null;
        _this.u9 = null;
        _this.u6 = null;
        _this.ry = null;
        _this.vs = null;
        _this.vt = null;
        _this.vp = null;
        _this.vu = null;
        _this.vv = null;
        _this.vq = null;
        _this.vr = null;
        _this.tg = null;
        _this.ul = 40;
        _this.sm = null;
        _this.sk = null;
        _this.so = null;
        _this.st = null;
        _this.v3 = null;
        _this.tc = null;
        _this.t0 = false;
        _this.tz = false;
        _this.t5 = false;
        _this.tm = false;
        _this.vg = 10;
        _this.un = NaN;
        _this.up = NaN;
        _this.uo = NaN;
        _this.uq = 0;
        _this.r4 = 0;
        _this.r7 = 0;
        _this.r9 = 0;
        _this.tj = true;
        _this.r0 = 0;
        _this.tk = false;
        _this.se = null;
        _this.sg = null;
        _this.t7 = null;
        _this.tl = true;
        _this.td = null;
        _this.sb = 1;
        _this.q2 = null;
        _this.q3 = null;
        _this.q4 = null;
        _this.q5 = null;
        _this.q7 = null;
        _this.q6 = null;
        _this.q1 = null;
        _this.q0 = null;
        _this.um = 1;
        _this.uk = 1;
        _this.uj = 1;
        _this.sq = null;
        _this.vc = -2147483648;
        _this.ui = 2;
        _this.vf = 3;
        _this.vd = 10;
        _this.vb = 30;
        _this.ve = 9;
        _this.rv = null;
        _this.rw = null;
        _this.rr = null;
        _this.applyCustomIndicators = null;
        _this.zo = null;
        _this.ur = 1;
        _this.ti = false;
        _this.si = null;
        _this.uf = dateMinValue();
        _this.ue = dateMaxValue();
        _this.uc = null;
        _this.hz();
        _this.uc = new ObservableCollection$1(Base.$, 0);
        if (_this.xAxisBreaks != null) {
            var a = _this.xAxisBreaks;
            a.collectionChanged = delegateCombine(a.collectionChanged, function (a, b) { return _this.zd(); });
        }
        _this.yy();
        return _this;
    }
    FinancialChart.prototype.i1 = function (a, b, c) {
        _super.prototype.i1.call(this, a, b, c);
        switch (a) {
            case "ToolbarTemplate":
            case "RangeSelectorTemplate":
                this.rz = new FinancialChartToolbar(this, this.v0);
                break;
            case "Toolbar":
                var d = b;
                if (d != null) {
                    d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.ym));
                    d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.yp));
                    d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.yq));
                    d.l(null);
                }
                if (this.rz != null) {
                    this.rz.ac = this.r6;
                    this.rz.ai = this.be;
                    this.rz.y = this.r1;
                    this.rz.al = this.tx;
                    if (this.u7 != null) {
                        this.rz.l(this.u7);
                    }
                    var e = this.rz;
                    e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.ym));
                    ;
                    var f = this.rz;
                    f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.yp));
                    var g = this.rz;
                    g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.yq));
                }
                break;
            case "ChartType":
                if (this.rz != null) {
                    this.rz.y = this.r1;
                }
                break;
            case "VolumeType":
                if (this.rz != null) {
                    this.rz.ac = this.r6;
                }
                break;
            case "TrendLineType":
                if (this.rz != null) {
                    this.rz.ai = this.be;
                }
                break;
            case "IsToolbarVisible":
                if (this.rz == null) {
                    break;
                }
                this.rz.al = this.tx;
                this.setGridRows();
                break;
        }
    };
    FinancialChart.prototype.yq = function (a, b) {
        this.r6 = this.rz.ac;
    };
    FinancialChart.prototype.yp = function (a, b) {
        this.be = this.rz.ai;
    };
    FinancialChart.prototype.ym = function (a, b) {
        this.r1 = this.rz.y;
    };
    FinancialChart.prototype.yy = function () {
        this.ss = new IndicatorPane();
        this.sj = TypeRegistrar.create("FinancialLegend");
    };
    FinancialChart.prototype.provideGrid = function (a) {
        this.va = a;
        this.zj();
        this.setGridRows();
        if (this.rz != null) {
            this.rz.bg(a);
        }
    };
    FinancialChart.prototype.onDocumentClick = function (a) {
        if (this.rz != null) {
            this.rz.bl(a);
        }
    };
    FinancialChart.prototype.getContext = function () {
        var a = this.rz.v();
        var b = new FinancialChartContext();
        b.vm = new FinancialChartViewModel();
        b.vm.toolbar = a;
        b.container = this.er;
        b.toolbarContainer = this.u7;
        b.legendContainer = this.u6;
        b.indicatorsContainer = this.u5;
        b.volumeContainer = this.u8;
        b.zoomContainer = this.u9;
        return b;
    };
    FinancialChart.prototype.provideContainer = function (a) {
        var b = a;
        if (b != null) {
            var c = "financialChartMainGrid";
            var d = b.createElement("div");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            if (this.rz == null) {
                this.rz = new FinancialChartToolbar(this, this.v0);
            }
            this.rz.w.isIndicatorMenuVisible = this.to && this.tp;
            this.u7 = b.getSubRenderer(d);
            this.rz.l(this.u7);
            var e = b.createElement("div");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("height", "100%");
            var f = b.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            this.u6 = b.getSubRenderer(f);
            var g = b.createElement("div");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "100%");
            this.u5 = b.getSubRenderer(g);
            var h = b.createElement("div");
            h.setStyleProperty("width", "100%");
            h.setStyleProperty("height", "100%");
            this.u8 = b.getSubRenderer(h);
            var i = b.createElement("div");
            i.setStyleProperty("width", "100%");
            i.setStyleProperty("height", "100%");
            this.u9 = b.getSubRenderer(i);
            a = b.getSubRenderer(e);
        }
        else {
            this.u7 = null;
            if (this.rz != null) {
                this.rz.l(null);
            }
            if (this.th != null) {
                this.th.provideContainer(null);
                this.th = null;
            }
            if (this.sj != null) {
                this.sj.provideContainer(null);
            }
        }
        _super.prototype.provideContainer.call(this, a);
        if (b != null) {
            if (this.volumeChart != null) {
                this.volumeChart.provideContainer(this.u8);
            }
            if (this.ss != null) {
                this.ss.h(this.u5);
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.provideContainer(this.u9);
                if (a != null) {
                    this.x6();
                }
                else {
                    this.th = null;
                }
            }
            if (this.sj != null) {
                this.sj.provideContainer(this.u6);
            }
            this.setGridRows();
        }
    };
    FinancialChart.prototype.y9 = function (a, b, c) {
        if (a != null) {
            a.provideContainer(null);
        }
        if (b != null) {
            b.provideContainer(c);
        }
        this.setGridRows();
    };
    FinancialChart.prototype.zn = function (a, b) {
        this.y9(a, b, this.u9);
        if (b == null) {
            return;
        }
        this.x6();
    };
    FinancialChart.prototype.x6 = function () {
        var _this = this;
        if (this.u9 == null) {
            return;
        }
        if (this.th != null) {
            this.th.provideContainer(null);
        }
        this.th = TypeRegistrar.create("ZoomSlider");
        this.th.provideContainer(this.u9);
        var a = this.th;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, function (a, b) {
            if (_this.dataChart != null) {
                _this.dataChart.o8 = new Rect(0, _this.th.windowRect.left, _this.dataChart.os.top, _this.th.windowRect.width, _this.dataChart.os.height);
            }
        });
        this.x7();
    };
    FinancialChart.prototype.zl = function (a, b) {
        this.y9(a, b, this.u8);
    };
    FinancialChart.prototype.setGridRows = function () {
        if (this.va == null) {
            return;
        }
        var a = new Array(6);
        a[0] = (this.tx ? this.uw : 0) + "px";
        a[1] = this.tt ? "min-content" : "0px";
        a[2] = "auto";
        a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
        a[4] = this.volumeChart == null ? "0px" : "100px";
        a[5] = this.zoomSliderChart == null ? "0px" : "100px";
        if (this.th != null) {
            if (a[5] == "0px") {
                this.th.hide();
            }
            else {
                this.th.show();
            }
        }
        this.va.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin.apply(void 0, __spreadArray([" "], __read(a))), "auto", "1fr"));
        this.va.setStyleProperty("grid-template-rows", stringJoin.apply(void 0, __spreadArray([" "], __read(a))));
        if (this.er == null) {
            return;
        }
        if (this.dataChart != null) {
            this.dataChart.notifyContainerResized();
        }
        if (this.ss != null) {
            this.ss.f();
        }
        if (this.volumeChart != null) {
            this.volumeChart.notifyContainerResized();
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.notifyContainerResized();
        }
        if (this.th != null) {
            this.th.notifySizeChanged();
        }
    };
    FinancialChart.prototype.ic = function () {
        _super.prototype.ic.call(this);
        this.kh = 3;
        this.pt = 0;
        this.d3 = NaN;
        this.dw = 30;
        this.cd = true;
        this.cj = false;
        if (this.dataChart != null) {
            var a = this.dataChart.b8.j.e();
            this.ra = a.d;
            this.rb = a.e;
            this.q9 = a.d;
            this.zp = this.dataChart.sj;
        }
        var b = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(139, 220, 92, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(139, 91, 177, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(109, 177, 255, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(115, 86, 86, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(140, 231, 217, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(168, 168, 183, .3)";
            return $ret;
        })()));
        this.rc = b;
        var c = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8bdc5c";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8b5bb1";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#6db1ff";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#735656";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8ce7d9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#a8a8b7";
            return $ret;
        })()));
        this.rd = c;
    };
    FinancialChart.prototype.y5 = function () {
        if (this.ss != null) {
            this.ss.b = null;
            this.ss.b = this.indicatorCharts;
        }
        this.setGridRows();
    };
    FinancialChart.prototype.y6 = function () {
        this.setGridRows();
    };
    FinancialChart.prototype.zf = function () {
        this.y5();
    };
    FinancialChart.prototype.x5 = function () {
        if (this.th == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
            return;
        }
        var a = this.er.rootWrapper.width();
        var b = this.dataChart.o7.left + this.dataChart.o7.width;
        var c = this.dataChart.o7.left;
        var d = a - b;
        this.th.startInset = c - this.th.trackStartInset;
        this.th.endInset = d - this.th.trackEndInset;
        if (this.th.endInset < 0) {
            var e = this.th.endInset;
            this.th.endInset = 0;
            this.dataChart.fk += (e * -1);
        }
        if (this.th.startInset < 0) {
            var f = this.th.startInset;
            this.th.startInset = 0;
            this.dataChart.fh += (f * -1);
        }
        this.zoomSliderChart.fh = c;
        this.zoomSliderChart.fk = d;
        this.zoomSliderChart.fd = this.th.barExtent;
    };
    FinancialChart.prototype.yw = function () {
        this.x5();
    };
    FinancialChart.prototype.h9 = function (a) {
        _super.prototype.h9.call(this, a);
        if (a != null) {
            a.fc = 0;
        }
    };
    FinancialChart.prototype.zq = function (a) {
        return a.ol();
    };
    FinancialChart.prototype.zt = function () {
        return this.u6 == null ? null : this.zs(this.u6.rootWrapper);
    };
    FinancialChart.prototype.zr = function (a) {
        if (a == null || a.d == null) {
            return null;
        }
        return this.zs(a.d.rootWrapper);
    };
    FinancialChart.prototype.zs = function (a) {
        if (a == null) {
            return null;
        }
        var b = a.getOffset();
        return new Rect(0, b.left, b.top, a.width(), a.height());
    };
    FinancialChart.prototype.us = function () {
        if (this.va == null) {
            return NaN;
        }
        var a = this.va.getOffset();
        return this.va.width() + (a == null ? 0 : a.left);
    };
    FinancialChart.prototype.il = function (source_, a, b) {
        _super.prototype.il.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.jg(source_, a, b);
        }
    };
    FinancialChart.prototype.im = function (source_, a, b) {
        _super.prototype.im.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.jh(source_, a, b);
        }
    };
    FinancialChart.prototype.ik = function (source_) {
        _super.prototype.ik.call(this, source_);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.jd(source_);
        }
    };
    FinancialChart.prototype.ip = function (source_, a, b, c) {
        _super.prototype.ip.call(this, source_, a, b, c);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.ji(source_, a, b, c);
        }
    };
    FinancialChart.prototype.ig = function (a, b) {
        _super.prototype.ig.call(this, a, b);
        if (this.tu(a)) {
            a.toolTip = null;
        }
    };
    Object.defineProperty(FinancialChart.prototype, "rz", {
        get: function () {
            return this.ry;
        },
        set: function (a) {
            var b = this.rz;
            if (a != b) {
                this.ry = a;
                this.iz("Toolbar", b, this.rz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "vz", {
        get: function () {
            return this.vs;
        },
        set: function (a) {
            var b = this.vz;
            if (a != b) {
                this.vs = a;
                this.iz("RangeSelectorTemplate", b, this.vz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "v0", {
        get: function () {
            return this.vt;
        },
        set: function (a) {
            var b = this.v0;
            if (a != b) {
                this.vt = a;
                this.iz("ToolbarTemplate", b, this.v0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "vw", {
        get: function () {
            return this.vp;
        },
        set: function (a) {
            var b = this.vw;
            if (a != b) {
                this.vp = a;
                this.iz("ChartTypePickerTemplate", b, this.vw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "v1", {
        get: function () {
            return this.vu;
        },
        set: function (a) {
            var b = this.v1;
            if (a != b) {
                this.vu = a;
                this.iz("TrendLineTypePickerTemplate", b, this.v1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "v2", {
        get: function () {
            return this.vv;
        },
        set: function (a) {
            var b = this.v2;
            if (a != b) {
                this.vv = a;
                this.iz("VolumeTypePickerTemplate", b, this.v2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "vx", {
        get: function () {
            return this.vq;
        },
        set: function (a) {
            var b = this.vx;
            if (a != b) {
                this.vq = a;
                this.iz("IndicatorMenuTemplate", b, this.vx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "vy", {
        get: function () {
            return this.vr;
        },
        set: function (a) {
            var b = this.vy;
            if (a != b) {
                this.vr = a;
                this.iz("OverlayPickerTemplate", b, this.vy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "th", {
        get: function () {
            return this.tg;
        },
        set: function (a) {
            var b = this.th;
            if (a != b) {
                this.tg = a;
                this.iz("ZoomSlider", b, this.th);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_dw = function () {
        return _super.prototype.get_dw.call(this);
    };
    FinancialChart.prototype.set_dw = function (a) {
        _super.prototype.set_dw.call(this, a);
    };
    FinancialChart.prototype.get_cd = function () {
        return _super.prototype.get_cd.call(this);
    };
    FinancialChart.prototype.set_cd = function (a) {
        _super.prototype.set_cd.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "uw", {
        get: function () {
            return this.ul;
        },
        set: function (a) {
            var b = this.uw;
            if (a != b) {
                this.ul = a;
                this.iz("ToolbarHeight", b, this.uw);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.ka = function () {
        return this.xAxis;
    };
    FinancialChart.prototype.kb = function () {
        return this.yAxis;
    };
    FinancialChart.prototype.onAttachedToUI = function () {
        _super.prototype.onAttachedToUI.call(this);
        if (this.th != null) {
            this.th.onAttachedToUI();
        }
    };
    FinancialChart.prototype.onDetachedFromUI = function () {
        _super.prototype.onDetachedFromUI.call(this);
        if (this.th != null) {
            this.th.onDetachedFromUI();
        }
    };
    FinancialChart.prototype.ab = function (a) {
        return 20;
    };
    FinancialChart.prototype.get_cv = function () {
        return ((function () {
            var $ret = new List$1(DataSeriesType_$type, 0);
            $ret.add(20);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "cv", {
        get: function () {
            return this.get_cv();
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_cu = function () {
        return ((function () {
            var $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleFinancialPriceSeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "cu", {
        get: function () {
            return this.get_cu();
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.rl = function (a) {
        return this.rm(a);
    };
    FinancialChart.prototype.sz = function (a) {
        return this.s0(a);
    };
    FinancialChart.prototype.rk = function (a) {
        var b = this.rl(0);
        b.name = a;
        return b;
    };
    FinancialChart.prototype.hw = function () {
        this.xAxis = this.rk("xAxis");
        this.yAxis = this.sz(0);
        this.yAxis.name = "yAxis";
        this.volumeAxis = this.sz(0);
        this.volumeAxis.name = "volumeAxis";
        this.volumeXAxis = this.rk("volumeXAxis");
        this.t9 = new List$1(NumericYAxis.$, 0);
        this.ub = new List$1(CategoryAxisBase.$, 0);
        this.indicatorAxis = this.sz(0);
        this.indicatorAxis.name = "indicatorAxis";
        this.indicatorXAxis = this.rk("indicatorXAxis_0");
        this.t9.add(this.indicatorAxis);
        this.ub.add(this.indicatorXAxis);
        if (this.xAxis.ay == null) {
            this.xAxis.ay = new AxisLabelSettings();
        }
        if (this.yAxis.ay == null) {
            this.yAxis.ay = new AxisLabelSettings();
        }
        if (this.volumeAxis.ay == null) {
            this.volumeAxis.ay = new AxisLabelSettings();
        }
        if (this.volumeXAxis.ay == null) {
            this.volumeAxis.ay = new AxisLabelSettings();
        }
        if (this.indicatorAxis.ay == null) {
            this.indicatorAxis.ay = new AxisLabelSettings();
        }
        if (this.indicatorXAxis.ay == null) {
            this.indicatorXAxis.ay = new AxisLabelSettings();
        }
        this.zoomSliderAxis = this.sz(0);
        this.zoomSliderAxis.name = "zoomSliderAxis";
        this.zoomSliderXAxis = this.rk("zoomSliderXAxis");
        if (this.zoomSliderAxis.ay == null) {
            this.zoomSliderAxis.ay = new AxisLabelSettings();
        }
        if (this.zoomSliderXAxis.ay == null) {
            this.zoomSliderXAxis.ay = new AxisLabelSettings();
        }
    };
    FinancialChart.prototype.hu = function (a, b) {
        var c = typeCast(MarkerSeries.$, a);
        if (c != null) {
            c.oi = this.av(a, b);
        }
    };
    FinancialChart.prototype.jf = function (a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.j2 = true;
            this.yAxis.kp = 10;
        }
    };
    FinancialChart.prototype.ji = function () {
        this.yAxis.j2 = this.t2;
        this.yAxis.kp = this.vo;
    };
    FinancialChart.prototype.r3 = function (a) {
        var b;
        if (this.r1 == 0) {
            if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                b = 4;
            }
            else {
                b = 2;
            }
        }
        else {
            b = this.r1;
        }
        b = this.r2(b);
        return b;
    };
    FinancialChart.prototype.r2 = function (a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.sc = function (a) {
        if ((a == 2 || a == 3)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 5;
        }
        if (a == 5) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 6;
        }
        if (a == 6) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.r5 = function (a) {
        if (a == 2) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 1;
        }
        if (a == 1) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.wb = function (a) {
        var b = a.getMemberPathFor(14);
        if (stringIsNullOrEmpty(b)) {
            b = a.getMemberPathFor(11);
        }
        return b;
    };
    FinancialChart.prototype.rm = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createXAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.s0 = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createYAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.s6 = function () {
        return this.a4(1);
    };
    FinancialChart.prototype.s7 = function () {
        return this.a4(0);
    };
    FinancialChart.prototype.s5 = function () {
        return this.a4(2);
    };
    FinancialChart.prototype.s8 = function () {
        return this.a4(20);
    };
    Object.defineProperty(FinancialChart.prototype, "tn", {
        get: function () {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sn", {
        get: function () {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tq", {
        get: function () {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sl", {
        get: function () {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "to", {
        get: function () {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sp", {
        get: function () {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tp", {
        get: function () {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "su", {
        get: function () {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.a3 = function (a, b) {
        var c = this.wb(a);
        switch (this.r3(a)) {
            case 3:
                var d = this.s6();
                this.sn.setValueMemberPath(d, c);
                this.sn.setXAxis(d, this.xAxis);
                this.sn.setYAxis(d, this.yAxis);
                this.sn.setCategoryMode(d, 1);
                return d;
            case 4:
                var e = this.s7();
                this.sn.setValueMemberPath(e, c);
                this.sn.setXAxis(e, this.xAxis);
                this.sn.setYAxis(e, this.yAxis);
                this.sn.setCategoryMode(e, 1);
                return e;
            default:
            case 1:
            case 2:
                var f = this.s8();
                this.sl.setOpenMemberPath(f, a.getMemberPathFor(11));
                this.sl.setHighMemberPath(f, a.getMemberPathFor(12));
                this.sl.setLowMemberPath(f, a.getMemberPathFor(13));
                this.sl.setCloseMemberPath(f, a.getMemberPathFor(14));
                this.sl.setVolumeMemberPath(f, a.getMemberPathFor(15));
                this.sl.setXAxis(f, this.xAxis);
                this.sl.setYAxis(f, this.yAxis);
                this.sl.setDisplayType(f, this.r1 == 1 ? 1 : 0);
                this.sl.setCategoryMode(f, 1);
                return f;
        }
    };
    FinancialChart.prototype.jh = function () {
        _super.prototype.jh.call(this);
        this.yu(this.xAxis);
        this.zh(false);
        if (this.r6 != 0 && this.volumeChart != null) {
            this.y0();
        }
        this.yu(this.volumeXAxis);
        this.yu(this.indicatorXAxis);
        this.ze();
        this.zg();
        if (this.sd != 0) {
            this.y1();
            this.yu(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.ph = function (a, b) {
        var e_1, _a;
        _super.prototype.ph.call(this, a, b);
        a(this.volumeXAxis);
        if (this.ub != null) {
            try {
                for (var _b = __values(fromEnum(this.ub)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    a(c);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
        var d = true;
        switch (b) {
            case "XAxisMajorStroke":
            case "XAxisMajorStrokeThickness":
                d = false;
                break;
        }
        if (d) {
            a(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.pl = function (a, b) {
        var e_2, _a;
        _super.prototype.pl.call(this, a, b);
        if (b) {
            a(this.volumeAxis);
            if (this.t9 != null) {
                try {
                    for (var _b = __values(fromEnum(this.t9)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        a(c);
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
            }
            a(this.zoomSliderAxis);
        }
    };
    FinancialChart.prototype.pj = function (a) {
        _super.prototype.pj.call(this, a);
        this.pb(this.volumeXAxis, a);
        this.pb(this.indicatorXAxis, a);
        this.pb(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.pn = function (a) {
        _super.prototype.pn.call(this, a);
        this.pb(this.volumeAxis, a);
        this.pb(this.indicatorAxis, a);
        this.pb(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.pm = function (a) {
        _super.prototype.pm.call(this, a);
        this.pa(this.volumeAxis, a);
        this.pa(this.indicatorAxis, a);
        this.pa(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.pi = function (a) {
        _super.prototype.pi.call(this, a);
        this.pa(this.volumeXAxis, a);
        this.pa(this.indicatorXAxis, a);
        this.pa(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.h8 = function (a) {
        var _this = this;
        _super.prototype.h8.call(this, a);
        if (a == null) {
            return;
        }
        if (a == this.zoomSliderChart) {
            a.py = a.p1 = false;
            a.legend = null;
            if (this.dataChart != null) {
                a.pe = this.dataChart.pe;
                a.ph = this.dataChart.ph;
            }
        }
        else {
            SyncManager.d(a, ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = _this.w5();
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })()));
            SyncManager.c(a);
        }
        a.bw = 2;
    };
    FinancialChart.prototype.w5 = function () {
        if (this.v3 == null) {
            FinancialChart.vn++;
            this.v3 = FinancialChart.vn.toString();
        }
        return this.v3;
    };
    FinancialChart.prototype.yg = function (a, b) {
        this.x2();
        this.yw();
    };
    FinancialChart.prototype.x2 = function () {
        var e_3, _a;
        if (this.yAxis.b1()) {
            return;
        }
        var a = this.yAxis.av.a6;
        if (this.r6 != 0) {
            a = Math.max(a, this.volumeAxis.av.a6);
        }
        try {
            for (var _b = __values(fromEnum(this.t9)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                a = Math.max(a, b.av.a6);
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        this.x3(a);
    };
    FinancialChart.prototype.x3 = function (a) {
        var e_4, _a;
        if (this.yAxis.b1()) {
            return;
        }
        this.yAxis.d7 = this.volumeAxis.d7 = a;
        try {
            for (var _b = __values(fromEnum(this.t9)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.d7 = a;
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.zoomSliderAxis.d7 = this.yAxis.d7;
    };
    FinancialChart.prototype.x8 = function (a) {
        if (this.indicatorCharts == null) {
            return;
        }
        for (var b = 0; b < this.indicatorCharts.count; b++) {
            var c = this.indicatorCharts._inner[b];
            for (var d = 0; d < c.series.count; d++) {
                a(c.series._inner[d], b);
            }
        }
    };
    FinancialChart.prototype.yb = function (a) {
        if (this.volumeChart == null) {
            return;
        }
        for (var b = 0; b < this.volumeChart.series.count; b++) {
            a(this.volumeChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.x9 = function (a) {
        if (this.dataChart == null) {
            return;
        }
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (!this.tu(c)) {
                continue;
            }
            a(c, b);
        }
    };
    FinancialChart.prototype.ya = function (a, b) {
        if (this.dataChart == null) {
            return;
        }
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.tu(d)) {
                continue;
            }
            var e = this.vh(d, c);
            a(d, e);
        }
        if (b) {
            this.yc(a);
        }
    };
    FinancialChart.prototype.yc = function (a) {
        if (this.zoomSliderChart == null) {
            return;
        }
        for (var b = 0; b < this.zoomSliderChart.series.count; b++) {
            a(this.zoomSliderChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.vh = function (a, b) {
        if (a.b4 != this.dataChart) {
            return b;
        }
        var c = this.ac == null || this.ac.dataSeries == null ? 0 : this.ac.dataSeries.count;
        var d = this.sh == null ? 0 : this.sh.count;
        return b - (c * d);
    };
    FinancialChart.prototype.h2 = function (a) {
        _super.prototype.h2.call(this, a);
        this.yb(a);
        this.x8(a);
        this.yc(a);
    };
    Object.defineProperty(FinancialChart.prototype, "volumeChart", {
        get: function () {
            return this.tc;
        },
        set: function (a) {
            var b = this.volumeChart;
            if (a != b) {
                this.tc = a;
                this.iz("VolumeChart", b, this.volumeChart);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.y0 = function () {
        if (this.dataChart == null) {
            return;
        }
        this.volumeChart.series.clear();
        var a = new List$1(Series.$, 0);
        var b = -1;
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.tu(d) || d.cx) {
                continue;
            }
            b++;
            var e = void 0;
            var f = this.r6;
            f = this.r5(f);
            switch (f) {
                case 2:
                    e = this.s7();
                    break;
                case 3:
                    e = this.s5();
                    break;
                default:
                case 1:
                    e = this.s6();
                    break;
            }
            this.sn.setCategoryMode(e, 1);
            e.name = "volumeSeries_" + b;
            e.itemsSource = d.itemsSource;
            this.sn.setXAxis(e, this.volumeXAxis);
            this.sn.setYAxis(e, this.volumeAxis);
            this.sn.setValueMemberPath(e, this.ac != null && this.ac.dataSeries != null && this.ac.dataSeries.count > b ? this.ac.dataSeries._inner[b].getMemberPathFor(15) : null);
            e.gy = d.gy + " Volume";
            e.nb = ArrayExtension.getModulus$1(Brush.$, this.re, b);
            e.ng = ArrayExtension.getModulus$1(Brush.$, this.rf, b);
            e.fv = this.ux;
            a.add(e);
        }
        var g = this.cr("volume", false);
        if (g != null) {
            a.o(g);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.volumeChart.series.add(i);
            this.id(i, h);
        }
    };
    FinancialChart.prototype.tr = function (a) {
        if (!this.tn) {
            return false;
        }
        return this.sn.matchesType(a);
    };
    FinancialChart.prototype.tv = function (a) {
        if (!this.tq) {
            return false;
        }
        return this.sl.matchesType(a);
    };
    FinancialChart.prototype.ts = function (a) {
        if (!this.to) {
            return false;
        }
        return this.sp.matchesType(a);
    };
    FinancialChart.prototype.tu = function (a) {
        if (!this.tp) {
            return false;
        }
        return this.su.matchesType(a);
    };
    FinancialChart.prototype.yz = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = 0;
        var b = this.sf == null ? 0 : this.sf.count;
        var c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var d = b + c;
        for (var e = 0; e < d; e++) {
            var f = new List$1(Series.$, 0);
            var g = this.indicatorCharts._inner[e];
            var h = e >= b;
            var i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.sf._inner[e]);
            var j = -1;
            for (var k = 0; k < this.dataChart.series.count; k++) {
                var l = this.dataChart.series._inner[k];
                if (this.tu(l) || l.cx) {
                    continue;
                }
                j++;
                var m = void 0;
                if (h) {
                    var n = this.s9("Custom");
                    this.sp.handleCustomIndicatorEvent(n, runOn(this, this.ye));
                    m = n;
                }
                else {
                    m = this.tb(this.sf._inner[e]);
                }
                if (m == null) {
                    continue;
                }
                m.name = "indicator_" + a++;
                this.sp.setXAxis(m, this.ub._inner[e]);
                this.sp.setYAxis(m, this.t9._inner[e]);
                m.itemsSource = l.itemsSource;
                this.sp.setOpenMemberPath(m, this.ac.dataSeries._inner[j].getMemberPathFor(11));
                this.sp.setHighMemberPath(m, this.ac.dataSeries._inner[j].getMemberPathFor(12));
                this.sp.setLowMemberPath(m, this.ac.dataSeries._inner[j].getMemberPathFor(13));
                this.sp.setCloseMemberPath(m, this.ac.dataSeries._inner[j].getMemberPathFor(14));
                this.sp.setVolumeMemberPath(m, this.ac.dataSeries._inner[j].getMemberPathFor(15));
                m.gy = l.gy + " " + i;
                m.nb = ArrayExtension.getModulus$1(Brush.$, this.q8, e);
                m.fv = this.uu;
                if (this.ts(m)) {
                    this.sp.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.q9, e));
                    this.sp.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.sr, e));
                }
                if (this.vj != -2147483648 && this.ts(m)) {
                    this.sp.setPeriodOverride(m, this.vj);
                }
                if (this.ts(m)) {
                    this.sp.setSmoothingPeriod(m, this.vm);
                }
                if (this.ts(m)) {
                    this.sp.setSignalPeriod(m, this.vl);
                }
                if (this.ts(m)) {
                    this.sp.setShortPeriod(m, this.vk);
                    this.sp.setLongPeriod(m, this.vi);
                }
                this.id(m, e);
                f.add(m);
            }
            var o = this.cr(i, false);
            for (var p = 0; p < f.count; p++) {
                var q = f._inner[p];
                g.series.add(q);
            }
            if (o != null) {
                for (var r = 0; r < o.count; r++) {
                    var s = o._inner[r];
                    g.series.add(s);
                    this.id(s, r);
                }
            }
        }
    };
    FinancialChart.prototype.s9 = function (indicatorName_) {
        return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
    };
    FinancialChart.prototype.tb = function (a) {
        return this.s9(EnumUtil.getName(FinancialIndicatorType_$type, a));
    };
    FinancialChart.prototype.zh = function (a) {
        if (this.rz == null) {
            return;
        }
        var b = this.xAxis;
        if (b.actualMinimumValue > b.actualMaximumValue) {
            return;
        }
        this.rz.as = b.actualMinimumValue;
        this.rz.ar = b.actualMaximumValue;
        if (a) {
            this.rz.au = b.visibleMinimum;
            this.rz.at = b.visibleMaximum;
        }
        this.rz.bn();
    };
    FinancialChart.prototype.es = function () {
        var e_5, _a, e_6, _b;
        var _this = this;
        var a = ((function () {
            var $ret = new FinancialChartVisualData();
            $ret.mainChart = _super.prototype.es.call(_this);
            $ret.volumeChart = _this.volumeChart == null ? null : _this.volumeChart.qx();
            $ret.toolbar = _this.rz == null ? null : _this.rz.aj();
            $ret.zoomChart = _this.zoomSliderChart == null ? null : _this.zoomSliderChart.qx();
            return $ret;
        })());
        if (this.indicatorCharts != null) {
            a.indicatorCharts = new List$1(Base.$, 0);
            try {
                for (var _c = __values(fromEnum(this.indicatorCharts)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    a.indicatorCharts.add1(b.qx());
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
        }
        if (this.dataChart != null) {
            a.mainChartLeft = this.zq(this.dataChart).x;
            a.mainChartTop = this.zq(this.dataChart).y;
        }
        if (this.volumeChart != null) {
            a.volumeChartLeft = this.zq(this.volumeChart).x;
            a.volumeChartTop = this.zq(this.volumeChart).y;
        }
        if (this.zoomSliderChart != null) {
            a.zoomChartLeft = this.zq(this.zoomSliderChart).x;
            a.zoomChartTop = this.zq(this.zoomSliderChart).y;
        }
        if (this.rz != null) {
            var c = this.zr(this.rz);
            a.toolbarLeft = c.left;
            a.toolbarTop = c.top;
            a.toolbarWidth = c.width;
            a.toolbarHeight = c.height;
        }
        if (this.indicatorCharts != null) {
            a.indicatorChartLefts = new List$1(Number_$type, 0);
            a.indicatorChartTops = new List$1(Number_$type, 0);
            try {
                for (var _e = __values(fromEnum(this.indicatorCharts)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var d = _f.value;
                    a.indicatorChartLefts.add(this.zq(d).x);
                    a.indicatorChartTops.add(this.zq(d).y);
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
        }
        var e = this.zt();
        a.legendLeft = e.left;
        a.legendTop = e.top;
        a.legendWidth = e.width;
        a.legendHeight = e.height;
        a.legend = this.sj == null ? null : this.sj.exportVisualData();
        return a;
    };
    FinancialChart.prototype.v8 = function () {
        var a = this.es();
        a.scaleByViewport();
        return a.serialize();
    };
    FinancialChart.prototype.ta = function (overlayName_) {
        return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
    };
    FinancialChart.prototype.zg = function () {
        var e_7, _a, e_8, _b;
        if (this.dataChart == null) {
            return;
        }
        var a = new List$1(Series.$, 0);
        try {
            for (var _c = __values(fromEnum(this.dataChart.series)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var b = _d.value;
                if (this.tu(b)) {
                    a.add(b);
                }
            }
        }
        catch (e_7_1) {
            e_7 = { error: e_7_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_7)
                    throw e_7.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var c = _f.value;
                this.dataChart.series.remove(c);
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        if (this.sh == null) {
            return;
        }
        var d = new List$1(Series.$, 0);
        var e = -1;
        for (var f = 0; f < this.dataChart.series.count; f++) {
            var g = this.dataChart.series._inner[f];
            if (this.tu(g) || g.cx) {
                continue;
            }
            e++;
            for (var h = 0; h < this.sh.count; h++) {
                var i = this.sh._inner[h];
                var j = void 0;
                switch (i) {
                    case 1:
                        j = this.ta(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                    default:
                    case 0:
                        j = this.ta(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                }
                j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                this.su.setXAxis(j, this.xAxis);
                this.su.setYAxis(j, this.yAxis);
                j.itemsSource = g.itemsSource;
                var k = e * this.sh.count + h;
                j.nb = ArrayExtension.getModulus$1(Brush.$, this.rc, k);
                j.ng = ArrayExtension.getModulus$1(Brush.$, this.rd, k);
                j.fv = this.uv;
                j.gy = g.gy + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                var l = g;
                if (l == null) {
                    continue;
                }
                var m = this.ac.dataSeries._inner[e];
                this.su.setOpenMemberPath(j, m.getMemberPathFor(11));
                this.su.setHighMemberPath(j, m.getMemberPathFor(12));
                this.su.setLowMemberPath(j, m.getMemberPathFor(13));
                this.su.setCloseMemberPath(j, m.getMemberPathFor(14));
                this.su.setVolumeMemberPath(j, m.getMemberPathFor(15));
                d.add(j);
            }
        }
        var n = new Array(this.dataChart.series.count);
        this.dataChart.series.copyTo(n, 0);
        this.dataChart.skipDataCleanup = true;
        this.dataChart.series.clear();
        this.dataChart.skipDataCleanup = false;
        for (var o = 0; o < n.length; o++) {
            n[o].gi = -1;
        }
        d.o(n);
        for (var p = 0; p < d.count; p++) {
            var q = d._inner[p];
            this.dataChart.series.add(q);
            this.id(q, p);
        }
    };
    FinancialChart.prototype.ze = function () {
        var e_9, _a;
        if (this.t0) {
            return;
        }
        this.t0 = true;
        if (this.indicatorCharts != null) {
            var a = this.indicatorCharts;
            this.indicatorCharts = null;
            try {
                for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    this.yv(b);
                }
            }
            catch (e_9_1) {
                e_9 = { error: e_9_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_9)
                        throw e_9.error;
                }
            }
        }
        if ((this.sf == null || this.sf.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
            this.indicatorCharts = null;
            if (this.t9 != null) {
                this.t9.clear();
            }
            if (this.ub != null) {
                this.ub.clear();
            }
            this.y5();
            this.zf();
            this.t0 = false;
            return;
        }
        if (this.indicatorCharts == null) {
            this.indicatorCharts = new List$1(XamDataChart.$, 0);
        }
        this.indicatorCharts.clear();
        this.t9.clear();
        this.ub.clear();
        var c = this.sf == null ? 0 : this.sf.count;
        var d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var e = c + d;
        for (var f = 0; f < e; f++) {
            var g = new XamDataChart();
            this.indicatorCharts.add(g);
            this.yt(g);
            var h = f >= c;
            if (h) {
                g.hy = this.customIndicatorNames._inner[f - c];
            }
            else {
                g.hy = this.wa(this.sf._inner[f]);
            }
            if (this.indicatorAxis != null) {
                var i = void 0;
                var j = void 0;
                if (f == 0) {
                    i = this.indicatorAxis;
                    j = this.indicatorXAxis;
                }
                else {
                    i = new NumericYAxis();
                    if (!this.indicatorXAxis.b7) {
                        j = this.rl(0);
                    }
                    else {
                        j = this.rl(1);
                    }
                }
                j.name = "indicatorXAxis_" + f;
                i.name = "indicatorAxis_" + f;
                g.axes.add(i);
                g.axes.add(j);
                this.t9.add(i);
                this.ub.add(j);
                if (this.b3) {
                    this.pe(i);
                }
                if (this.b3) {
                    this.pc(j);
                }
            }
        }
        this.yz();
        this.y5();
        if (this.rz != null) {
            this.rz.ae = this.sf;
        }
        this.x4();
        this.zf();
        this.t0 = false;
    };
    FinancialChart.prototype.h5 = function () {
        var e_10, _a, e_11, _b;
        _super.prototype.h5.call(this);
        this.pc(this.xAxis);
        this.pc(this.volumeXAxis);
        if (this.ub != null) {
            try {
                for (var _c = __values(fromEnum(this.ub)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var a = _d.value;
                    this.pc(a);
                }
            }
            catch (e_10_1) {
                e_10 = { error: e_10_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_10)
                        throw e_10.error;
                }
            }
        }
        this.pe(this.yAxis);
        this.pe(this.volumeAxis);
        if (this.t9 != null) {
            try {
                for (var _e = __values(fromEnum(this.t9)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var b = _f.value;
                    this.pe(b);
                }
            }
            catch (e_11_1) {
                e_11 = { error: e_11_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_11)
                        throw e_11.error;
                }
            }
        }
        this.pc(this.zoomSliderXAxis);
        this.pe(this.zoomSliderAxis);
    };
    FinancialChart.prototype.get_ci = function () {
        return !this.ty;
    };
    Object.defineProperty(FinancialChart.prototype, "t4", {
        get: function () {
            return (this.externalObject._dynamicContent);
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.zm = function (a, b) {
        this.y8(a, b);
        this.x4();
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
            this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
        }
        this.y1();
        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
        this.y6();
        this.zn(a, b);
    };
    FinancialChart.prototype.y1 = function () {
        if (this.dataChart == null || this.zoomSliderChart == null) {
            return;
        }
        this.zoomSliderChart.series.clear();
        var a = new List$1(Series.$, 0);
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (this.tu(c) || c.cx) {
                continue;
            }
            var d = void 0;
            var e = this.sd;
            e = this.sc(e);
            var f = this.vh(c, b);
            if (e == 1) {
                switch (this.r3(this.ac != null && this.ac.dataSeries != null && this.ac.dataSeries.count > f ? this.ac.dataSeries._inner[f] : null)) {
                    case 1:
                        e = 2;
                        break;
                    case 2:
                        e = 3;
                        break;
                    case 3:
                        e = 4;
                        break;
                    case 4:
                        e = 5;
                        break;
                }
            }
            switch (e) {
                case 2:
                    d = this.s8();
                    this.sl.setDisplayType(d, 1);
                    break;
                case 3:
                    d = this.s8();
                    this.sl.setDisplayType(d, 0);
                    break;
                case 5:
                    d = this.s7();
                    break;
                case 6:
                    d = this.s5();
                    break;
                default:
                case 4:
                    d = this.s6();
                    break;
            }
            var g = this.ac != null && this.ac.dataSeries != null && this.ac.dataSeries.count > f ? this.ac.dataSeries._inner[f] : null;
            if (d.cz && !d.c6) {
                this.sn.setCategoryMode(d, 1);
                this.sn.setXAxis(d, this.zoomSliderXAxis);
                this.sn.setYAxis(d, this.zoomSliderAxis);
                this.sn.setValueMemberPath(d, g == null ? null : this.wb(g));
            }
            else if (d.c6) {
                this.sl.setCategoryMode(d, 1);
                this.sl.setXAxis(d, this.zoomSliderXAxis);
                this.sl.setYAxis(d, this.zoomSliderAxis);
                if (g != null) {
                    this.sl.setOpenMemberPath(d, g.getMemberPathFor(11));
                    this.sl.setHighMemberPath(d, g.getMemberPathFor(12));
                    this.sl.setLowMemberPath(d, g.getMemberPathFor(13));
                    this.sl.setCloseMemberPath(d, g.getMemberPathFor(14));
                    this.sl.setVolumeMemberPath(d, g.getMemberPathFor(15));
                }
            }
            d.name = "zoomSliderSeries_" + f;
            d.itemsSource = c.itemsSource;
            d.gy = c.gy;
            a.add(d);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.zoomSliderChart.series.add(i);
            this.id(i, h);
        }
    };
    FinancialChart.prototype.iu = function (a, b, c) {
        var e_12, _a;
        _super.prototype.iu.call(this, a, b, c);
        if (a == null || !b) {
            return;
        }
        var d = true;
        var e = true;
        switch (c) {
            case "Brushes":
            case "Outlines":
                d = e = false;
                break;
        }
        if (this.indicatorCharts != null && d) {
            try {
                for (var _b = __values(fromEnum(this.indicatorCharts)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    a(f);
                }
            }
            catch (e_12_1) {
                e_12 = { error: e_12_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_12)
                        throw e_12.error;
                }
            }
        }
        if (this.volumeChart != null && e) {
            a(this.volumeChart);
        }
        if (this.zoomSliderChart != null) {
            a(this.zoomSliderChart);
        }
    };
    FinancialChart.prototype.ye = function (a, b) {
        var c = b;
        var d = a;
        var e = -1;
        if (this.indicatorCharts != null) {
            e = this.indicatorCharts.indexOf(d.b4);
        }
        e -= this.sf == null ? 0 : this.sf.count;
        if (this.applyCustomIndicators != null) {
            this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
        }
    };
    FinancialChart.prototype.za = function (a, b, c) {
        if (a != null) {
            if (b != null) {
                a.axes.remove(b);
            }
            a.axes.add(c);
        }
        if (this.b3) {
            this.pc(c);
        }
    };
    Object.defineProperty(FinancialChart.prototype, "t3", {
        get: function () {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.yf = function (a, b) {
        this.ze();
    };
    FinancialChart.prototype.tw = function (a, b) {
        if (b <= (0)) {
            return false;
        }
        switch (a) {
            case 5: return true;
            case 4:
            case 3: return b >= timeSpanFromDays(365);
            case 2: return b >= timeSpanFromDays(180);
            case 1: return b >= timeSpanFromDays(90);
            case 0: return b >= timeSpanFromDays(30);
        }
        return false;
    };
    FinancialChart.prototype.y4 = function () {
        var e_13, _a;
        var a = this.rx != null ? this.rx : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
        var b = new FinancialChartRangeSelectorOptionCollection(0);
        var c = this.xAxis;
        var d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (this.tw(e, d)) {
                    b.add(e);
                }
            }
        }
        catch (e_13_1) {
            e_13 = { error: e_13_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_13)
                    throw e_13.error;
            }
        }
        this.rw = b;
        if (this.rz != null) {
            this.rz.u = this.rw;
        }
    };
    FinancialChart.prototype.yj = function (a, b) {
        this.y4();
    };
    FinancialChart.prototype.yo = function (a, b) {
        this.sh = this.rz.ag;
    };
    FinancialChart.prototype.yn = function (a, b) {
        this.sf = this.rz.ae;
    };
    FinancialChart.prototype.yh = function (a, b) {
        this.ze();
    };
    FinancialChart.prototype.yi = function (a, b) {
        this.zg();
    };
    FinancialChart.prototype.ys = function (a, b) {
        var c = a;
        if (c.bf == null) {
            return;
        }
        if (this.ty) {
            this.y3(c.bf);
        }
    };
    FinancialChart.prototype.yv = function (a) {
        SyncManager.e(a);
        a.axes.clear();
        a.series.clear();
        a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.yg));
        a.provideContainer(null);
        if (this.volumeChart == null && this.indicatorCharts == null) {
            this.yAxis.d7 = this.volumeAxis.d7 = this.indicatorAxis.d7 = 0;
            this.xAxis.ay.visibility = this.qy;
        }
    };
    FinancialChart.prototype.yt = function (a) {
        var b = a != this.zoomSliderChart;
        if (b) {
            if (this.dataChart != null) {
                a.o8 = new Rect(0, this.dataChart.os.x, a.o8.y, this.dataChart.os.width, a.o8.height);
            }
            var c = ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = "one";
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })());
            SyncManager.d(a, c);
            SyncManager.c(a);
        }
        a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.yg));
        this.h7(a);
    };
    FinancialChart.prototype.x4 = function () {
        if (this.indicatorCharts != null || this.volumeChart != null) {
            this.pa(this.xAxis, function (a) { return a.visibility = 1; });
        }
        var _loop_1 = function (a) {
            var b = this_1.ub._inner[a];
            var c = a < this_1.ub.count - 1 || this_1.volumeChart != null;
            this_1.pa(b, function (d) { return d.visibility = c ? 1 : 0; });
        };
        var this_1 = this;
        for (var a = 0; a < this.ub.count; a++) {
            _loop_1(a);
        }
    };
    FinancialChart.prototype.y8 = function (a, b) {
        if (a != null) {
            this.yv(a);
        }
        if (b != null) {
            this.yt(b);
        }
    };
    FinancialChart.prototype.zk = function (a, b) {
        this.y8(a, b);
        this.x4();
        if (this.volumeChart != null) {
            if (this.volumeAxis != null) {
                this.volumeChart.axes.add(this.volumeAxis);
                this.volumeChart.axes.add(this.volumeXAxis);
            }
            this.y0();
            this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
        }
        this.zl(a, b);
    };
    FinancialChart.prototype.yk = function (a, b) {
        this.zi();
    };
    FinancialChart.prototype.zi = function () {
        if (this.rz == null || +(this.rz.au) == +(dateMaxValue()) || +(this.rz.at) == +(dateMinValue()) || this.dataChart == null) {
            return;
        }
        var a = this.xAxis;
        var b = a.getWindowRectForSelection(this.rz.au, this.rz.at);
        if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
            return;
        }
        this.tz = true;
        this.dataChart.o8 = new Rect(0, b.left, this.dataChart.o8.top, b.width, this.dataChart.o8.height);
        if (this.th != null) {
            this.th.windowRect = this.dataChart.os;
        }
        if (this.ty) {
            this.y3(this.dataChart);
        }
        this.tz = false;
    };
    FinancialChart.prototype.yr = function (a, b) {
        this.y4();
        this.zh(!this.tz);
    };
    FinancialChart.prototype.yd = function (a, b) {
        var _this = this;
        if (!this.tz) {
            if (this.ty) {
                this.y3(a);
            }
            var c = false;
            var d = this.i4(function () { return _this.zh(true); }, c);
            c = d.p1;
            if (this.th != null) {
                this.th.windowRect = this.dataChart.os;
            }
        }
    };
    FinancialChart.prototype.zc = function (a, b, c, d) {
        var e_14, _a;
        if (a == null || b == null) {
            return;
        }
        if (c != -1) {
            this.tz = true;
            a.o8 = new Rect(0, d, a.os.top, c, a.os.height);
            this.tz = false;
        }
        var e = 1.7976931348623157E+308;
        var f = -1.7976931348623157E+308;
        var g = new Rect(0, 0, 0, 1, 1);
        var h = new ScalerParams(0, g, g, this.yAxis.ca, a.ow);
        try {
            for (var _b = __values(fromEnum(a.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var i = _c.value;
                h.b = i.fa();
                var j = i.ap(a.os);
                var k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                var l = b.dz(j.c, h);
                var m = b.dz(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
        }
        catch (e_14_1) {
            e_14 = { error: e_14_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_14)
                    throw e_14.error;
            }
        }
        var n = a.os.width;
        if (c != -1) {
            n = c;
        }
        var o = a.os.left;
        if (d != -1) {
            o = d;
        }
        if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
            return;
        }
        this.tz = true;
        var p = new Rect(0, o, e, n, f - e);
        a.o8 = p;
        this.tz = false;
    };
    FinancialChart.prototype.zb = function (a) {
        if (a == null) {
            return;
        }
        if (a == this.dataChart) {
            this.zc(this.dataChart, this.yAxis, -1, -1);
            if (this.volumeChart != null) {
                this.zc(this.volumeChart, this.volumeAxis, this.dataChart.os.width, this.dataChart.os.left);
            }
        }
        else if (a == this.volumeChart) {
            this.zc(this.volumeChart, this.volumeAxis, -1, -1);
            this.zc(this.dataChart, this.yAxis, this.volumeChart.os.width, this.volumeChart.os.left);
        }
    };
    FinancialChart.prototype.y3 = function (a) {
        var _this = this;
        this.i3(function () { return _this.zb(a); });
    };
    FinancialChart.prototype.yl = function (a, b) {
        if (this.ty) {
            this.y3(a);
        }
    };
    FinancialChart.prototype.zj = function () {
        if (!this.t4) {
            return;
        }
        this.x7();
        if (this.sd == 0) {
            this.zoomSliderChart = null;
        }
        else if (this.zoomSliderChart == null) {
            this.zoomSliderChart = ((function () {
                var $ret = new XamDataChart();
                $ret.name = "ZoomSliderChart";
                return $ret;
            })());
        }
        else {
            this.y1();
        }
    };
    FinancialChart.prototype.x7 = function () {
        var container_ = this.u9.rootWrapper.getNativeElement();
        var containerParent_ = container_.parentElement;
        if (this.th != null && containerParent_ != null && !this.t5) {
            this.t5 = true;
            if (TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                var z_ = this.th;
                var f_ = this.externalObject;
                var sliderComponent_ = TypeRegistrar.get("IgxZoomSliderComponent");
                var sliderInstance_ = TypeRegistrar.create("IgxZoomSliderComponent");
                sliderInstance_._implementation = z_;
                sliderComponent_._staticStyling(container_, sliderInstance_, f_);
            }
        }
    };
    FinancialChart.prototype.zd = function () {
        var _this = this;
        if (this.r8 != 1) {
            return;
        }
        this.pg(function (a) {
            var e_15, _a;
            var b;
            b = a.breaks;
            b.clear();
            if (_this.xAxisBreaks == null) {
                return;
            }
            try {
                for (var _b = __values(fromEnum(_this.xAxisBreaks)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    b.add(c);
                }
            }
            catch (e_15_1) {
                e_15 = { error: e_15_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_15)
                        throw e_15.error;
                }
            }
        });
    };
    FinancialChart.prototype.jm = function (a, b, c) {
        _super.prototype.jm.call(this, a, b, c);
        if (this.ac.dataSeries.count > 0) {
            if (this.r8 == 1 && stringIsNullOrEmpty(this.fo)) {
                this.aj.setXMemberPath(a, c.getMemberPathFor(17));
            }
            if (stringIsNullOrEmpty(this.fq)) {
                this.aj.setYMemberPath(a, this.wb(c));
            }
            if (stringIsNullOrEmpty(this.fk)) {
                this.aj.setLabelMemberPath(a, this.wb(c));
            }
            if (stringIsNullOrEmpty(this.fh)) {
                this.aj.setContentMemberPath(a, this.wb(c));
            }
        }
    };
    FinancialChart.prototype.wa = function (a) {
        switch (a) {
            case 0: return "Absolute Volume Oscillator";
            case 1: return "Accumulation/Distribution Indicator";
            case 2: return "Average Directional Index";
            case 3: return "Average True Range Indicator";
            case 4: return "Bollinger Bandwidth";
            case 5: return "Chaikin Oscillator";
            case 6: return "Chaikin Volatility Indicator";
            case 7: return "Commodity Channel Index";
            case 8: return "Detrended Price Oscillator";
            case 9: return "Ease of Movement Indicator";
            case 10: return "Fast Stochastic Oscillator";
            case 11: return "Force Index Indicator";
            case 12: return "Full Stochastic Oscillator";
            case 13: return "Market Facilitation Index";
            case 14: return "Mass Index Indicator";
            case 15: return "Median Price Indicator";
            case 16: return "Money Flow Index";
            case 17: return "MACD Indicator";
            case 18: return "Negative Volume Index";
            case 19: return "On Balance Volume Indicator";
            case 20: return "Percentage Price Oscillator";
            case 21: return "Percentage Volume Oscillator";
            case 22: return "Positive Volume Index";
            case 23: return "Price Volume Trend";
            case 24: return "ROC - Rate of Change Indicator";
            case 25: return "RSI - Relative Strength Index";
            case 26: return "Slow Stochastic Oscillator";
            case 27: return "Standard Deviation Indicator";
            case 28: return "Stoch RSI";
            case 29: return "TRIX Indicator";
            case 30: return "Typical Price Indicator";
            case 31: return "Ultimate Oscillator";
            case 32: return "Weighted Close Indicator";
            case 33: return "Williams %R Indicator";
            default: return "Unknown";
        }
    };
    FinancialChart.prototype.pc = function (a) {
        var e_16, _a;
        _super.prototype.pc.call(this, a);
        var b = a;
        this.yu(b);
        if (a.bf != null) {
            try {
                for (var _b = __values(fromEnum(a.bf.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (this.tr(c)) {
                        this.sn.setXAxis(c, b);
                    }
                    else if (this.tv(c)) {
                        this.sl.setXAxis(c, b);
                    }
                    else if (this.ts(c)) {
                        this.sp.setXAxis(c, b);
                    }
                    else if (this.tu(c)) {
                        this.su.setXAxis(c, b);
                    }
                }
            }
            catch (e_16_1) {
                e_16 = { error: e_16_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_16)
                        throw e_16.error;
                }
            }
        }
        var d = a == this.zoomSliderXAxis;
        if (d) {
            a.it = this.zp;
            a.d6 = this.u4;
            this.pa(a, function (e) { return e.visibility = 1; });
        }
        var e = a;
        e.minimumValue = this.uh;
        e.maximumValue = this.ug;
    };
    FinancialChart.prototype.pe = function (a) {
        var e_17, _a;
        _super.prototype.pe.call(this, a);
        if (a.bf != null && a == this.yAxis) {
            try {
                for (var _b = __values(fromEnum(a.bf.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (this.tr(b)) {
                        this.sn.setYAxis(b, this.yAxis);
                    }
                    else if (this.tv(b)) {
                        this.sl.setYAxis(b, this.yAxis);
                    }
                    else if (this.ts(b)) {
                        this.sp.setYAxis(b, this.yAxis);
                    }
                    else if (this.tu(b)) {
                        this.su.setYAxis(b, this.yAxis);
                    }
                }
            }
            catch (e_17_1) {
                e_17 = { error: e_17_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_17)
                        throw e_17.error;
                }
            }
        }
        a.jx = this.t1;
        a.kl = this.u2;
        a.kk = this.u1;
        if (a == this.yAxis) {
            a.kh = this.u0;
        }
        var c = a == this.zoomSliderAxis;
        if (c) {
            this.pa(a, function (d) { return d.visibility = 1; });
        }
    };
    FinancialChart.prototype.yu = function (a) {
        a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        a.fa = XYChart.m0(a, this.ac.dataSeries);
        if (this.ac.dataSeries.count > 0) {
            var b = this.ac.dataSeries._inner[0].getMemberPathFor(17);
            a.g2(b);
        }
    };
    FinancialChart.prototype.id = function (a, b) {
        _super.prototype.id.call(this, a, b);
        if (a == null) {
            return;
        }
        var c = this.zoomSliderChart == a.b4;
        var d = this.dataChart != null && this.dataChart.series.contains(a);
        if ((d || c) && a.de) {
            a.k8(this.ra != null ? ArrayExtension.getModulus$1(Brush.$, this.ra, b) : null, this.rb != null ? ArrayExtension.getModulus$1(Brush.$, this.rb, b) : null);
        }
        var e = this.ts(a);
        if (this.tu(a)) {
            a.nb = this.rc != null ? ArrayExtension.getModulus$1(Brush.$, this.rc, b) : null;
            a.ng = this.rd != null ? ArrayExtension.getModulus$1(Brush.$, this.rd, b) : null;
            a.fv = this.uv;
        }
        else if (e) {
            a.nb = this.q8 != null ? ArrayExtension.getModulus$1(Brush.$, this.q8, b) : null;
            a.fv = this.uu;
        }
        else if (!a.cx && (d || c)) {
            a.nb = this.n != null ? ArrayExtension.getModulus$1(Brush.$, this.n, b) : null;
            a.ng = this.r != null ? ArrayExtension.getModulus$1(Brush.$, this.r, b) : null;
        }
        var f = this.volumeChart != null && this.volumeChart == a.b4;
        if (f) {
            a.fv = this.ux;
        }
        a.legend = c || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.tt ? this.sj : null;
    };
    FinancialChart.prototype.iz = function (a, b, c) {
        var e_18, _a, e_19, _b;
        var _this = this;
        _super.prototype.iz.call(this, a, b, c);
        switch (a) {
            case "YAxisIsLogarithmic":
                this.yAxis.j2 = this.t2;
                if (this.volumeAxis != null) {
                    this.volumeAxis.j2 = this.t2;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.j2 = this.t2;
                }
                break;
            case "YAxisLogarithmBase":
                this.yAxis.kp = this.vo;
                if (this.volumeAxis != null) {
                    this.volumeAxis.kp = this.vo;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.kp = this.vo;
                }
                break;
            case "VolumeType":
                var d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                if (this.r6 == 0) {
                    this.volumeChart = null;
                }
                else if (this.volumeChart == null) {
                    this.volumeChart = ((function () {
                        var $ret = new XamDataChart();
                        $ret.name = "VolumeChart";
                        return $ret;
                    })());
                }
                else {
                    this.y0();
                }
                break;
            case "VolumeChart":
                this.zk(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "DataChart":
                if (typeCast(XamDataChart.$, b) !== null) {
                    var e = b;
                    e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.yg));
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.yd));
                    e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.yl));
                }
                if (this.dataChart != null) {
                    var f = this.dataChart;
                    f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.yg));
                    var g = this.dataChart;
                    g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.yd));
                    var h = this.dataChart;
                    h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.yl));
                }
                this.zj();
                break;
            case "XAxisMode":
                this.xAxis = this.rl(this.r8);
                this.xAxis.name = "xAxis";
                this.volumeXAxis = this.rl(this.r8);
                this.volumeXAxis.name = "volumeXAxis";
                this.indicatorXAxis = this.rl(this.r8);
                this.indicatorXAxis.name = "indicatorXAxis_0";
                this.zoomSliderXAxis = this.rl(this.r8);
                this.zoomSliderXAxis.name = "zoomSliderXAxis";
                this.pa(this.zoomSliderXAxis, function (i) { return i.visibility = 1; });
                this.x4();
                if (this.r8 == 1) {
                    this.zd();
                }
                break;
            case "YAxisMode":
                this.yAxis = this.sz(this.sa);
                this.yAxis.name = "yAxis";
                this.zoomSliderAxis = this.sz(this.sa);
                this.zoomSliderAxis.name = "zoomSliderAxis";
                this.volumeAxis = this.sz(this.sa);
                this.volumeAxis.name = "volumeAxis";
                break;
            case "Toolbar":
                var i = typeCast(FinancialChartToolbar.$, b);
                if (i != null) {
                    i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.yk));
                    i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.yn));
                    i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.yo));
                }
                if (this.rz != null) {
                    this.rz.ae = this.sf;
                    this.rz.ag = this.sh;
                    this.rz.u = this.rw;
                    this.zh(true);
                    var j = this.rz;
                    j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.yk));
                    var k = this.rz;
                    k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.yn));
                    var l = this.rz;
                    l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.yo));
                }
                break;
            case "XAxis":
                var m = typeCast(CategoryAxisBase.$, b);
                if (m != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(m);
                    }
                }
                var n = typeCast(ITimeRangeSelectorAxis_$type, b);
                if (n != null) {
                    n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.yr));
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.xAxis);
                }
                if (this.b3) {
                    this.pc(this.xAxis);
                    this.h0();
                }
                this.zh(false);
                this.zi();
                this.y4();
                var o = this.xAxis;
                o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.yr));
                break;
            case "ChartType":
                this.jh();
                break;
            case "VolumeXAxis":
                this.za(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                break;
            case "ZoomSliderXAxis":
                this.za(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                break;
            case "IndicatorXAxis":
                this.ze();
                break;
            case "YAxis":
                var p = typeCast(NumericYAxis.$, b);
                if (p != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(p);
                    }
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.yAxis);
                }
                if (this.b3) {
                    this.pe(this.yAxis);
                    this.pe(this.yAxis);
                }
                var q = this.yAxis;
                q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.ys));
                break;
            case "VolumeAxis":
                var r = typeCast(Axis.$, b);
                if (this.volumeChart != null && r != null) {
                    this.volumeChart.axes.remove(r);
                }
                if (this.volumeChart != null && this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.y0();
                }
                if (this.b3) {
                    this.pe(this.volumeAxis);
                }
                var s = this.volumeAxis;
                s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.ys));
                break;
            case "IndicatorAxis":
                if (this.indicatorCharts != null) {
                    for (var t = 0; t < this.indicatorCharts.count; t++) {
                        var u = this.indicatorCharts._inner[t];
                        var v = new List$1(Axis.$, 0);
                        try {
                            for (var _c = (e_18 = void 0, __values(fromEnum(u.axes))), _d = _c.next(); !_d.done; _d = _c.next()) {
                                var w = _d.value;
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                        }
                        catch (e_18_1) {
                            e_18 = { error: e_18_1 };
                        }
                        finally {
                            try {
                                if (_d && !_d.done && (_a = _c.return))
                                    _a.call(_c);
                            }
                            finally {
                                if (e_18)
                                    throw e_18.error;
                            }
                        }
                        try {
                            for (var _e = (e_19 = void 0, __values(fromEnum(v))), _f = _e.next(); !_f.done; _f = _e.next()) {
                                var x = _f.value;
                                u.axes.remove(x);
                            }
                        }
                        catch (e_19_1) {
                            e_19 = { error: e_19_1 };
                        }
                        finally {
                            try {
                                if (_f && !_f.done && (_b = _e.return))
                                    _b.call(_e);
                            }
                            finally {
                                if (e_19)
                                    throw e_19.error;
                            }
                        }
                        var y = null;
                        if (t == 0) {
                            y = this.indicatorAxis;
                        }
                        else if (this.sa == 1) {
                            y = this.sz(this.sa);
                        }
                        else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                            y = new NumericYAxis();
                        }
                        if (y != null) {
                            u.axes.add(y);
                        }
                        if (this.b3) {
                            this.pe(y);
                        }
                    }
                }
                break;
            case "IsWindowSyncedToVisibleRange":
                if (this.dataChart != null) {
                    this.dataChart.p1 = this.cj && this.ci;
                }
                if (this.volumeChart != null) {
                    this.volumeChart.p1 = this.cj && this.ci;
                }
                if (this.ty) {
                    this.zb(this.dataChart);
                }
                else {
                    this.volumeChart.qv = 1;
                }
                break;
            case "IndicatorTypes":
                var z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                if (z != null) {
                    z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.yh));
                }
                var aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                if (aa != null) {
                    aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.yh));
                }
                this.ze();
                break;
            case "OverlayTypes":
                var ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                if (ab != null) {
                    ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.yi));
                }
                var ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                if (ac != null) {
                    ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.yi));
                }
                this.zg();
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.pk(function (ad) { return ad.jx = _this.t1; });
                break;
            case "YAxisMinimumValue":
                this.pl(function (ad) { return ad.kl = _this.u2; }, false);
                break;
            case "YAxisMaximumValue":
                this.pl(function (ad) { return ad.kk = _this.u1; }, false);
                break;
            case "YAxisInterval":
                this.pl(function (ad) { return ad.kh = _this.u0; }, false);
                break;
            case "ZoomSliderType":
                this.zj();
                break;
            case "ZoomSliderChart":
                if (!this.t3) {
                    return;
                }
                this.zm(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.ya(function (ad, ae) {
                    if (ad.de) {
                        ad.k8(_this.ra != null ? ArrayExtension.getModulus$1(Brush.$, _this.ra, ae) : null, _this.rb != null ? ArrayExtension.getModulus$1(Brush.$, _this.rb, ae) : null);
                    }
                }, true);
                break;
            case "OverlayBrushes":
                this.h2(function (ad, ae) {
                    if (!(_this.tu(ad))) {
                        return;
                    }
                    ad.nb = _this.rc != null ? ArrayExtension.getModulus$1(Brush.$, _this.rc, ae) : null;
                });
                break;
            case "OverlayOutlines":
                this.h2(function (ad, ae) {
                    if (!(_this.tu(ad))) {
                        return;
                    }
                    ad.ng = _this.rd != null ? ArrayExtension.getModulus$1(Brush.$, _this.rd, ae) : null;
                });
                break;
            case "OverlayThickness":
                this.h2(function (ad, ae) {
                    if (!(_this.tu(ad))) {
                        return;
                    }
                    ad.fv = _this.uv;
                });
                break;
            case "VolumeBrushes":
                this.yb(function (ad, ae) { return ad.nb = ArrayExtension.getModulus$1(Brush.$, _this.re, ae); });
                break;
            case "VolumeOutlines":
                this.yb(function (ad, ae) { return ad.ng = ArrayExtension.getModulus$1(Brush.$, _this.rf, ae); });
                break;
            case "VolumeThickness":
                this.yb(function (ad, ae) { return ad.fv = _this.ux; });
                break;
            case "IndicatorNegativeBrushes":
                this.x8(function (ad, ae) { return _this.sp.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, _this.q9, ae)); });
                break;
            case "IndicatorBrushes":
                this.x8(function (ad, ae) { return ad.nb = ArrayExtension.getModulus$1(Brush.$, _this.q8, ae); });
                break;
            case "IndicatorThickness":
                this.x8(function (ad, ae) { return ad.fv = _this.uu; });
                break;
            case "IndicatorDisplayTypes":
                this.x8(function (ad, ae) { return _this.sp.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, _this.sr, ae)); });
                break;
            case "IndicatorPeriod":
                this.x8(function (ad, ae) {
                    if (_this.vj == -2147483648 || !(_this.ts(ad))) {
                        return;
                    }
                    _this.sp.setPeriodOverride(ad, _this.vj);
                });
                break;
            case "IndicatorMultiplier":
                this.x8(function (ad, ae) {
                    if (!(_this.tu(ad))) {
                        return;
                    }
                    _this.su.setMultiplier(ad, _this.ut);
                });
                break;
            case "IndicatorSmoothingPeriod":
                this.x8(function (ad, ae) {
                    if (!(_this.ts(ad))) {
                        return;
                    }
                    _this.sp.setSmoothingPeriod(ad, _this.vm);
                });
                break;
            case "IndicatorShortPeriod":
                this.x8(function (ad, ae) {
                    if (!(_this.ts(ad))) {
                        return;
                    }
                    _this.sp.setShortPeriod(ad, _this.vk);
                });
                break;
            case "IndicatorLongPeriod":
                this.x8(function (ad, ae) {
                    if (!(_this.ts(ad))) {
                        return;
                    }
                    _this.sp.setLongPeriod(ad, _this.vi);
                });
                break;
            case "IndicatorSignalPeriod":
                this.x8(function (ad, ae) {
                    if (!(_this.ts(ad))) {
                        return;
                    }
                    _this.sp.setSignalPeriod(ad, _this.vl);
                });
                break;
            case "RangeSelectorOptions":
                var ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                if (ad != null) {
                    ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.yj));
                }
                if (this.rx != null) {
                    var ae = this.rx;
                    ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.yj));
                }
                this.y4();
                break;
            case "CustomIndicatorNames":
                var af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                if (af != null) {
                    af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.yf));
                }
                if (this.customIndicatorNames != null) {
                    var ag = this.customIndicatorNames;
                    ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.yf));
                }
                this.ze();
                break;
            case "Legend":
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.legend = null;
                }
                break;
            case "Brushes":
                this.ya(function (ah, ai) { return ah.nb = _this.n != null ? ArrayExtension.getModulus$1(Brush.$, _this.n, ai) : null; }, true);
                break;
            case "Outlines":
                this.ya(function (ah, ai) { return ah.ng = _this.r != null ? ArrayExtension.getModulus$1(Brush.$, _this.r, ai) : null; }, true);
                break;
            case "XAxisLabelVisibility":
                if (this.qy == 0 && this.zoomSliderXAxis != null) {
                    this.pa(this.zoomSliderXAxis, function (ah) { return ah.visibility = 1; });
                }
                this.x4();
                break;
            case "YAxisLabelVisibility":
                if (this.qz != 0 || this.zoomSliderAxis == null) {
                    break;
                }
                this.pa(this.zoomSliderAxis, function (ah) { return ah.visibility = 1; });
                break;
            case "ZoomSliderXAxisMajorStroke":
                this.zoomSliderXAxis.it = this.zp;
                break;
            case "ZoomSliderXAxisMajorStrokeThickness":
                this.zoomSliderXAxis.d6 = this.u4;
                break;
            case "FinancialChartLegend":
            case "IsLegendVisible":
                var ah_1 = this.tt && this.legend == null;
                {
                    var ai = function (aj, ak) {
                        if (aj.isUsableInLegend) {
                            aj.legend = ah_1 ? _this.sj : null;
                        }
                    };
                    this.ya(ai, false);
                    this.x9(ai);
                }
                break;
            case "ZoomSliderAxis":
                var aj = typeCast(Axis.$, b);
                if (aj != null && this.zoomSliderChart != null) {
                    this.zoomSliderChart.axes.remove(aj);
                }
                if (this.zoomSliderAxis != null) {
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                        this.y1();
                        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                    }
                    if (this.b3) {
                        this.pe(this.zoomSliderAxis);
                    }
                    this.pa(this.zoomSliderAxis, function (ak) { return ak.visibility = 1; });
                }
                break;
            case "XAxisMinimumValue":
                this.pg(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.minimumValue = _this.uh;
                    }
                });
                break;
            case "XAxisMaximumValue":
                this.pg(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.maximumValue = _this.ug;
                    }
                });
                break;
        }
    };
    Object.defineProperty(FinancialChart.prototype, "t2", {
        get: function () {
            return this.tm;
        },
        set: function (a) {
            var b = this.t2;
            if (a != b) {
                this.tm = a;
                this.iz("YAxisIsLogarithmic", b, this.t2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "vo", {
        get: function () {
            return this.vg;
        },
        set: function (a) {
            var b = this.vo;
            if (a != b) {
                this.vg = a;
                this.iz("YAxisLogarithmBase", b, this.vo);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "u0", {
        get: function () {
            return this.un;
        },
        set: function (a) {
            var b = this.u0;
            if (a != b) {
                this.un = a;
                this.iz("YAxisInterval", b, this.u0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "u2", {
        get: function () {
            return this.up;
        },
        set: function (a) {
            var b = this.u2;
            if (a != b) {
                this.up = a;
                this.iz("YAxisMinimumValue", b, this.u2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "u1", {
        get: function () {
            return this.uo;
        },
        set: function (a) {
            var b = this.u1;
            if (a != b) {
                this.uo = a;
                this.iz("YAxisMaximumValue", b, this.u1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "u3", {
        get: function () {
            return this.uq;
        },
        set: function (a) {
            var b = this.u3;
            if (a != b) {
                this.uq = a;
                this.iz("YAxisMinorInterval", b, this.u3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "uz", {
        get: function () {
            return this.yAxis.kd;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "uy", {
        get: function () {
            return this.yAxis.kc;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "r6", {
        get: function () {
            return this.r4;
        },
        set: function (a) {
            var b = this.r6;
            if (a != b) {
                this.r4 = a;
                this.iz("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.r6));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "r8", {
        get: function () {
            return this.r7;
        },
        set: function (a) {
            var b = this.r8;
            if (a != b) {
                this.r7 = a;
                this.iz("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.r8));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sa", {
        get: function () {
            return this.r9;
        },
        set: function (a) {
            var b = this.sa;
            if (a != b) {
                this.r9 = a;
                this.iz("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.sa));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tx", {
        get: function () {
            return this.tj;
        },
        set: function (a) {
            var b = this.tx;
            if (a != b) {
                this.tj = a;
                this.iz("IsToolbarVisible", b, this.tx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "r1", {
        get: function () {
            return this.r0;
        },
        set: function (a) {
            var b = this.r1;
            if (a != b) {
                this.r0 = a;
                this.iz("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.r1));
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_pt = function () {
        return _super.prototype.get_pt.call(this);
    };
    FinancialChart.prototype.set_pt = function (a) {
        _super.prototype.set_pt.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "ty", {
        get: function () {
            return this.tk;
        },
        set: function (a) {
            var b = this.ty;
            if (a != b) {
                this.tk = a;
                this.iz("IsWindowSyncedToVisibleRange", b, this.ty);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sf", {
        get: function () {
            return this.se;
        },
        set: function (a) {
            var b = this.sf;
            if (a != b) {
                this.se = a;
                this.iz("IndicatorTypes", b, this.sf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sh", {
        get: function () {
            return this.sg;
        },
        set: function (a) {
            var b = this.sh;
            if (a != b) {
                this.sg = a;
                this.iz("OverlayTypes", b, this.sh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorCharts", {
        get: function () {
            return this.t7;
        },
        set: function (a) {
            var b = this.indicatorCharts;
            if (a != b) {
                this.t7 = a;
                this.iz("IndicatorCharts", b, this.indicatorCharts);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "t1", {
        get: function () {
            return this.tl;
        },
        set: function (a) {
            var b = this.t1;
            if (a != b) {
                this.tl = a;
                this.iz("YAxisAbbreviateLargeNumbers", b, this.t1);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_d3 = function () {
        return _super.prototype.get_d3.call(this);
    };
    FinancialChart.prototype.set_d3 = function (a) {
        _super.prototype.set_d3.call(this, a);
    };
    FinancialChart.prototype.get_kh = function () {
        return _super.prototype.get_kh.call(this);
    };
    FinancialChart.prototype.set_kh = function (a) {
        _super.prototype.set_kh.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "zoomSliderChart", {
        get: function () {
            return this.td;
        },
        set: function (a) {
            var b = this.zoomSliderChart;
            if (a != b) {
                this.td = a;
                this.iz("ZoomSliderChart", b, this.zoomSliderChart);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderAxis", {
        get: function () {
            return this.sy;
        },
        set: function (a) {
            var b = this.zoomSliderAxis;
            if (a != b) {
                this.sy = a;
                this.iz("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderXAxis", {
        get: function () {
            return this.rj;
        },
        set: function (a) {
            var b = this.zoomSliderXAxis;
            if (a != b) {
                this.rj = a;
                this.iz("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sd", {
        get: function () {
            return this.sb;
        },
        set: function (a) {
            var b = this.sd;
            if (a != b) {
                this.sb = a;
                this.iz("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.sd));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ra", {
        get: function () {
            return this.q2;
        },
        set: function (a) {
            var b = this.ra;
            if (a != b) {
                this.q2 = a;
                this.iz("NegativeBrushes", b, this.ra);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rb", {
        get: function () {
            return this.q3;
        },
        set: function (a) {
            var b = this.rb;
            if (a != b) {
                this.q3 = a;
                this.iz("NegativeOutlines", b, this.rb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rc", {
        get: function () {
            return this.q4;
        },
        set: function (a) {
            var b = this.rc;
            if (a != b) {
                this.q4 = a;
                this.iz("OverlayBrushes", b, this.rc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rd", {
        get: function () {
            return this.q5;
        },
        set: function (a) {
            var b = this.rd;
            if (a != b) {
                this.q5 = a;
                this.iz("OverlayOutlines", b, this.rd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rf", {
        get: function () {
            return this.q7;
        },
        set: function (a) {
            var b = this.rf;
            if (a != b) {
                this.q7 = a;
                this.iz("VolumeOutlines", b, this.rf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "re", {
        get: function () {
            return this.q6;
        },
        set: function (a) {
            var b = this.re;
            if (a != b) {
                this.q6 = a;
                this.iz("VolumeBrushes", b, this.re);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q9", {
        get: function () {
            return this.q1;
        },
        set: function (a) {
            var b = this.q9;
            if (a != b) {
                this.q1 = a;
                this.iz("IndicatorNegativeBrushes", b, this.q9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q8", {
        get: function () {
            return this.q0;
        },
        set: function (a) {
            var b = this.q8;
            if (a != b) {
                this.q0 = a;
                this.iz("IndicatorBrushes", b, this.q8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ux", {
        get: function () {
            return this.um;
        },
        set: function (a) {
            var b = this.ux;
            if (a != b) {
                this.um = a;
                this.iz("VolumeThickness", b, this.ux);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "uv", {
        get: function () {
            return this.uk;
        },
        set: function (a) {
            var b = this.uv;
            if (a != b) {
                this.uk = a;
                this.iz("OverlayThickness", b, this.uv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "uu", {
        get: function () {
            return this.uj;
        },
        set: function (a) {
            var b = this.uu;
            if (a != b) {
                this.uj = a;
                this.iz("IndicatorThickness", b, this.uu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sr", {
        get: function () {
            return this.sq;
        },
        set: function (a) {
            var b = this.sr;
            if (a != b) {
                this.sq = a;
                this.iz("IndicatorDisplayTypes", b, this.sr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "vj", {
        get: function () {
            return this.vc;
        },
        set: function (a) {
            var b = this.vj;
            if (a != b) {
                this.vc = a;
                this.iz("IndicatorPeriod", b, this.vj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ut", {
        get: function () {
            return this.ui;
        },
        set: function (a) {
            var b = this.ut;
            if (a != b) {
                this.ui = a;
                this.iz("IndicatorMultiplier", b, this.ut);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "vm", {
        get: function () {
            return this.vf;
        },
        set: function (a) {
            var b = this.vm;
            if (a != b) {
                this.vf = a;
                this.iz("IndicatorSmoothingPeriod", b, this.vm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "vk", {
        get: function () {
            return this.vd;
        },
        set: function (a) {
            var b = this.vk;
            if (a != b) {
                this.vd = a;
                this.iz("IndicatorShortPeriod", b, this.vk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "vi", {
        get: function () {
            return this.vb;
        },
        set: function (a) {
            var b = this.vi;
            if (a != b) {
                this.vb = a;
                this.iz("IndicatorLongPeriod", b, this.vi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "vl", {
        get: function () {
            return this.ve;
        },
        set: function (a) {
            var b = this.vl;
            if (a != b) {
                this.ve = a;
                this.iz("IndicatorSignalPeriod", b, this.vl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rx", {
        get: function () {
            return this.rv;
        },
        set: function (a) {
            var b = this.rx;
            if (a != b) {
                this.rv = a;
                this.iz("RangeSelectorOptions", b, this.rx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "customIndicatorNames", {
        get: function () {
            return this.rr;
        },
        set: function (a) {
            var b = this.rr;
            if (a != b) {
                this.rr = a;
                this.iz("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_cj = function () {
        return _super.prototype.get_cj.call(this);
    };
    FinancialChart.prototype.set_cj = function (a) {
        _super.prototype.set_cj.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "zp", {
        get: function () {
            return this.zo;
        },
        set: function (a) {
            var b = this.zp;
            if (a != b) {
                this.zo = a;
                this.iz("ZoomSliderXAxisMajorStroke", b, this.zp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "u4", {
        get: function () {
            return this.ur;
        },
        set: function (a) {
            var b = this.u4;
            if (a != b) {
                this.ur = a;
                this.iz("ZoomSliderXAxisMajorStrokeThickness", b, this.u4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tt", {
        get: function () {
            return this.ti;
        },
        set: function (a) {
            var b = this.tt;
            if (a != b) {
                this.ti = a;
                this.iz("IsLegendVisible", b, this.tt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sj", {
        get: function () {
            return this.si;
        },
        set: function (a) {
            var b = this.sj;
            if (a != b) {
                this.si = a;
                this.iz("FinancialChartLegend", b, this.sj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxis", {
        get: function () {
            return this.ri;
        },
        set: function (a) {
            var b = this.xAxis;
            if (a != b) {
                this.ri = a;
                this.iz("XAxis", b, this.xAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "yAxis", {
        get: function () {
            return this.sx;
        },
        set: function (a) {
            var b = this.yAxis;
            if (a != b) {
                this.sx = a;
                this.iz("YAxis", b, this.yAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeAxis", {
        get: function () {
            return this.sw;
        },
        set: function (a) {
            var b = this.volumeAxis;
            if (a != b) {
                this.sw = a;
                this.iz("VolumeAxis", b, this.volumeAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeXAxis", {
        get: function () {
            return this.rh;
        },
        set: function (a) {
            var b = this.volumeXAxis;
            if (a != b) {
                this.rh = a;
                this.iz("VolumeXAxis", b, this.volumeXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorAxis", {
        get: function () {
            return this.sv;
        },
        set: function (a) {
            var b = this.indicatorAxis;
            if (a != b) {
                this.sv = a;
                this.iz("IndicatorAxis", b, this.indicatorAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorXAxis", {
        get: function () {
            return this.rg;
        },
        set: function (a) {
            var b = this.indicatorXAxis;
            if (a != b) {
                this.rg = a;
                this.iz("IndicatorXAxis", b, this.indicatorXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "t9", {
        get: function () {
            return this.t6;
        },
        set: function (a) {
            var b = this.t9;
            if (a != b) {
                this.t6 = a;
                this.iz("IndicatorAxes", b, this.t9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ub", {
        get: function () {
            return this.t8;
        },
        set: function (a) {
            var b = this.ub;
            if (a != b) {
                this.t8 = a;
                this.iz("IndicatorXAxes", b, this.ub);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "uh", {
        get: function () {
            return this.uf;
        },
        set: function (a) {
            var b = this.uh;
            if (+a != +b) {
                this.uf = a;
                this.iz("XAxisMinimumValue", b, this.uh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ug", {
        get: function () {
            return this.ue;
        },
        set: function (a) {
            var b = this.ug;
            if (+a != +b) {
                this.ue = a;
                this.iz("XAxisMaximumValue", b, this.ug);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxisBreaks", {
        get: function () {
            return this.uc;
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
    FinancialChart.vn = 0;
    return FinancialChart;
}(XYChart));
export { FinancialChart };
/**
 * @hidden
 */
var FinancialChartToolbar = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartToolbar, _super);
    function FinancialChartToolbar(a, b) {
        var _this = _super.call(this, "financialChartToolbar", b, "") || this;
        _this.o = null;
        _this.r = null;
        _this.z = null;
        _this.p = null;
        _this.w = null;
        _this.aq = dateMaxValue();
        _this.ap = dateMinValue();
        _this.ao = dateMaxValue();
        _this.an = dateMinValue();
        _this.rangeChanged = null;
        _this.chartTypeChanged = null;
        _this.trendLineTypeChanged = null;
        _this.volumeTypeChanged = null;
        _this.indicatorTypesChanged = null;
        _this.overlayTypesChanged = null;
        _this.x = 0;
        _this.ah = 0;
        _this.ab = 0;
        _this.ad = null;
        _this.af = null;
        _this.t = null;
        _this.ak = false;
        _this.o = a;
        _this.w = new FinancialChartToolbarViewModel();
        _this.s = new FinancialChartRangeSelector(a != null ? a.vz : null);
        _this.aa = new FinancialChartTypePicker(a != null ? a.vw : null);
        _this.q = new FinancialChartIndicatorMenu(1, a != null ? a.vx : null);
        return _this;
    }
    FinancialChartToolbar.prototype.bg = function (a) {
        var b = a.querySelectorAll(".financialChartToolbarArea");
        if (b != null && b.length > 0) {
            this.g = b[0];
            if (!this.al) {
                this.g.hide();
            }
        }
        var c = a.querySelectorAll(".financialChartIndicatorMenu");
        if (c != null && c.length > 0) {
            this.q.g = c[0];
        }
        var d = a.querySelectorAll(".financialChartRangeSelector");
        if (d != null && d.length > 0) {
            this.s.g = d[0];
        }
        var e = a.querySelectorAll(".financialChartTypePicker");
        if (e != null && e.length > 0) {
            this.aa.g = e[0];
        }
    };
    FinancialChartToolbar.prototype.bl = function (a) {
        this.q.u(a);
        this.aa.u(a);
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "s", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.s;
            if (a != b) {
                this.r = a;
                this.bm("RangeSelector", b, this.s);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "aa", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.aa;
            if (a != b) {
                this.z = a;
                this.bm("ChartTypePicker", b, this.aa);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "q", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.q;
            if (a != b) {
                this.p = a;
                this.bm("IndicatorMenu", b, this.q);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.prototype.bm = function (a, b, c) {
        switch (a) {
            case "RangeStart":
                if (this.s != null) {
                    this.s.t = this.as;
                }
                break;
            case "RangeEnd":
                if (this.s != null) {
                    this.s.s = this.ar;
                }
                break;
            case "SelectionStart":
                if (this.s != null) {
                    this.s.v = this.au;
                }
                break;
            case "SelectionEnd":
                if (this.s != null) {
                    this.s.u = this.at;
                }
                break;
            case "RangeSelector":
                var d = b;
                if (d != null) {
                    d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                }
                if (this.s != null) {
                    this.s.t = this.as;
                    this.s.s = this.ar;
                    this.s.o = this.u;
                    this.s.v = this.au;
                    this.s.u = this.at;
                    var e = this.s;
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                }
                break;
            case "ChartTypePicker":
                var f = b;
                if (f != null) {
                    f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                }
                if (this.aa != null) {
                    this.aa.w = this.y;
                    var g = this.aa;
                    g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                }
                break;
            case "ChartType":
                if (this.aa != null) {
                    this.aa.w = this.y;
                }
                break;
            case "RangeSelectorOptions":
                if (this.s != null) {
                    this.s.o = this.u;
                }
                break;
            case "IsToolbarVisible":
                if (this.g == null) {
                    break;
                }
                if (this.al) {
                    this.g.show();
                }
                else {
                    this.g.hide();
                }
                break;
            case "IndicatorMenu":
                var h = typeCast(FinancialChartIndicatorMenu.$, b);
                if (h != null) {
                    h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                }
                if (this.q != null) {
                    var i = this.q;
                    i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                }
                break;
            case "IndicatorTypes":
                if (this.indicatorTypesChanged != null) {
                    this.indicatorTypesChanged(this, EventArgs.empty);
                }
                break;
            case "OverlayTypes":
                if (this.overlayTypesChanged != null) {
                    this.overlayTypesChanged(this, EventArgs.empty);
                }
                break;
            case "TrendLineType":
                if (this.trendLineTypeChanged != null) {
                    this.trendLineTypeChanged(this, EventArgs.empty);
                }
                break;
            case "VolumeType":
                if (this.volumeTypeChanged != null) {
                    this.volumeTypeChanged(this, EventArgs.empty);
                }
                break;
        }
    };
    FinancialChartToolbar.prototype.bh = function (a, b) {
        this.ag = this.q.z;
        this.ae = this.q.y;
        this.ai = this.q.aa;
        this.ac = this.q.x;
    };
    FinancialChartToolbar.prototype.bi = function (a, b) {
        this.y = this.aa.w;
        if (this.chartTypeChanged != null) {
            this.chartTypeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bj = function (a, b) {
        this.au = this.s.v;
        this.at = this.s.u;
        if (this.rangeChanged != null) {
            this.rangeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.v = function () {
        var _this = this;
        var a = new FinancialChartToolbarContext();
        a.container = this.d;
        a.vm = this.w;
        a.vm.financialChartIndicatorMenu = ((function () {
            var $ret = new FinancialChartIndicatorMenuContext();
            $ret.vm = _this.q.p;
            return $ret;
        })());
        a.vm.financialChartTypePicker = ((function () {
            var $ret = new FinancialChartTypePickerContext();
            $ret.vm = _this.aa.p;
            return $ret;
        })());
        a.vm.financialChartRangeSelector = ((function () {
            var $ret = new FinancialChartRangeSelectorContext();
            $ret.vm = _this.s.q;
            return $ret;
        })());
        return a;
    };
    FinancialChartToolbar.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        if (a == null) {
            return;
        }
        this.s.l(a);
        this.aa.l(a);
        this.q.l(a);
        this.bk();
    };
    FinancialChartToolbar.prototype.bk = function () {
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "au", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.au;
            if (+a != +b) {
                this.aq = a;
                this.bm("SelectionStart", b, this.au);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "at", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.at;
            if (+a != +b) {
                this.ap = a;
                this.bm("SelectionEnd", b, this.at);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "as", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.as;
            if (+a != +b) {
                this.ao = a;
                this.bm("RangeStart", b, this.as);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ar", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.ar;
            if (+a != +b) {
                this.an = a;
                this.bm("RangeEnd", b, this.ar);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.prototype.bn = function () {
        if (this.s != null) {
            this.s.ab();
        }
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "y", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.y;
            if (a != b) {
                this.x = a;
                this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ai", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ai;
            if (a != b) {
                this.ah = a;
                this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ac", {
        get: function () {
            return this.ab;
        },
        set: function (a) {
            var b = this.ac;
            if (a != b) {
                this.ab = a;
                this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ae", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ae;
            if (!FinancialChartToolbar.am(b, a)) {
                this.ad = a;
                this.bm("IndicatorTypes", b, this.ae);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ag", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.ag;
            if (!FinancialChartToolbar.am(b, a)) {
                this.af = a;
                this.bm("OverlayTypes", b, this.ag);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.am = function (a, b) {
        var e_20, _a;
        if (a == b) {
            return true;
        }
        if ((a == null && b != null) || (a != null && b == null)) {
            return false;
        }
        if (a.count != b.count) {
            return false;
        }
        try {
            for (var _b = __values(fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (!b.contains(c)) {
                    return false;
                }
            }
        }
        catch (e_20_1) {
            e_20 = { error: e_20_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_20)
                    throw e_20.error;
            }
        }
        return true;
    };
    FinancialChartToolbar.prototype.aj = function () {
        var _this = this;
        return ((function () {
            var $ret = new FinancialChartToolbarVisualData();
            $ret.rangeSelector = _this.s == null ? null : _this.s.r();
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "u", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.u;
            if (a != b) {
                this.t = a;
                this.bm("RangeSelectorOptions", b, this.u);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "al", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.al;
            if (a != b) {
                this.ak = a;
                this.bm("IsToolbarVisible", b, this.al);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
}(TemplatedHtmlControl));
export { FinancialChartToolbar };
/**
 * @hidden
 */
var FinancialChartRangeSelector = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartRangeSelector, _super);
    function FinancialChartRangeSelector(a) {
        var _this = _super.call(this, "financialChartRangeSelector", a, "") || this;
        _this.q = null;
        _this.rangeChanged = null;
        _this.p = null;
        _this.p = new FinancialChartRangeSelectorView();
        _this.q = new FinancialChartRangeSelectorViewModel();
        _this.q.onRangeChanged = runOn(_this, _this.z);
        _this.p.c = _this.q;
        return _this;
    }
    Object.defineProperty(FinancialChartRangeSelector.prototype, "v", {
        get: function () {
            return this.q.selectionStart;
        },
        set: function (a) {
            this.q.selectionStart = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "u", {
        get: function () {
            return this.q.selectionEnd;
        },
        set: function (a) {
            this.q.selectionEnd = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "t", {
        get: function () {
            return this.q.rangeStart;
        },
        set: function (a) {
            this.q.rangeStart = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "s", {
        get: function () {
            return this.q.rangeEnd;
        },
        set: function (a) {
            this.q.rangeEnd = a;
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.ab = function () {
        if (this.q.onPropertiesChanged()) {
            this.p.g(this.q);
        }
    };
    FinancialChartRangeSelector.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        this.p.f(this.d, this.q);
    };
    FinancialChartRangeSelector.prototype.z = function () {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, EventArgs.empty);
        }
    };
    FinancialChartRangeSelector.prototype.r = function () {
        return this.p.d(this.g);
    };
    Object.defineProperty(FinancialChartRangeSelector.prototype, "o", {
        get: function () {
            return this.q.options;
        },
        set: function (a) {
            var b = !FinancialChartToolbar.am(this.q.options, a);
            if (b) {
                this.q.options = a;
                this.aa();
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.aa = function () {
        if (this.q != null) {
            this.q.ao();
        }
        if (this.p != null) {
            this.p.i(this.o);
        }
    };
    FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    FinancialChartRangeSelector.x = 0;
    return FinancialChartRangeSelector;
}(TemplatedHtmlControl));
export { FinancialChartRangeSelector };
//# sourceMappingURL=FinancialChart_combined.js.map
